; ##############################################################################
; ##############################################################################
; ##############################################################################
MENUE:
	LDS temp1,(adr_TASTE)
	cpi temp1,(TASTE_MENUE_PLUS)		; vergleich TASTENWERT		
	brne MENUE_PLUS_FERTIG
	LDS temp,(adr_MENUE)
	inc temp						; MENUE+1					
	STS(adr_MENUE),temp
MENUE_PLUS_FERTIG:
;-------------------------------------------------------------------------------
	cpi temp1,(TASTE_MENUE_MINUS)	; vergleich TASTENWERT		
	brne MENUE_MINUS_FERTIG
	LDS temp,(adr_MENUE)
	tst temp						; berlauf	?
	breq MENUE_MINUS_FERTIG
	dec temp						; MENUE-1					
	STS(adr_MENUE),temp
MENUE_MINUS_FERTIG:
;-------------------------------------------------------------------------------
	; GRAFIC clear					
	tst temp1
	breq TASTEN_MENUE_ACTION
	call GRAFIC_CLEAR
;-------------------------------------------------------------------------------
TASTEN_MENUE_ACTION:
	LDS temp,(adr_MENUE)		; MENUE						
	ldi ZL,LOW (TASTEN_MENUE_SRUNGMARKE)	; Z-initialisieren	
	ldi ZH,HIGH(TASTEN_MENUE_SRUNGMARKE)
	add ZL,temp
	adc ZH,NULL
	ijmp 					; SPRUNG nach Z	(rjmp->1Words jmp->2Words) 
;-------------------------------------------------------------------------------
TASTEN_MENUE_SRUNGMARKE:
	rjmp MENUE_DIAGRAMM
	rjmp MENUE_INFO
	rjmp MENUE_STATUS
	rjmp MENUE_WARNUNG
	rjmp MENUE_ASCII
	rjmp MENUE_HH
	rjmp MENUE_MM
	rjmp MENUE_SS
	rjmp MENUE_TAG
	rjmp MENUE_MONAT
	rjmp MENUE_JAHR
	rjmp MENUE_WOCHENTAG
	rjmp MENUE_ALARM_SCHWELLE
	rjmp MENUE_SAVE_RESET
	; BERLAUF		
	STS(adr_MENUE),NULL
	STS(adr_TASTE),NULL
	rjmp MENUE
;-------------------------------------------------------------------------------
MENUE_DIAGRAMM:
	call DIAGRAMM_ALARM
	call DIAGRAMM_ZEICHNEN
ret
;-------------------------------------------------------------------------------
MENUE_STATUS:
	; X Y Z					
	call ASCII_CURSOR_ZEILE_1
	LDS temp1,(adr_BMA020_X_L)
	LDS temp2,(adr_BMA020_X_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	call ASCII_SPACE
	LDS temp1,(adr_BMA020_Y_L)
	LDS temp2,(adr_BMA020_Y_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	call ASCII_SPACE
	LDS temp1,(adr_BMA020_Z_L)
	LDS temp2,(adr_BMA020_Z_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	; X Y Z (OFFSET)		
	call ASCII_CURSOR_ZEILE_2
	LDS temp1,(adr_BMA020_X_OFFSET_L)
	LDS temp2,(adr_BMA020_X_OFFSET_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	call ASCII_SPACE
	LDS temp1,(adr_BMA020_Y_OFFSET_L)
	LDS temp2,(adr_BMA020_Y_OFFSET_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	call ASCII_SPACE
	LDS temp1,(adr_BMA020_Z_OFFSET_L)
	LDS temp2,(adr_BMA020_Z_OFFSET_H)
	call ANZEIGE_5_STELLEN_SIGNIERT_TEMP1_TEMP2
	call ASCII_SPACE
	; TAKT					
	call ASCII_CURSOR_ZEILE_4
	call ASCII_T
	call ASCII_A
	call ASCII_K
	call ASCII_T
	call ASCII_SPACE
	ldi temp1,BYTE1(TAKT)
	ldi temp2,BYTE2(TAKT)
	ldi temp3,BYTE3(TAKT)
	ldi temp4,BYTE4(TAKT)
	call ANZEIGE_8_STELLEN_TEMP1_TEMP2_TEMP3_TEMP4
	call ASCII_SPACE
	ldi temp1,LOW (TIMER0_FREQUENZ_BERECHNET)
	ldi temp2,HIGH(TIMER0_FREQUENZ_BERECHNET)
	call ANZEIGE_5_STELLEN_TEMP1_TEMP2

	; RAM					
	call ASCII_CURSOR_ZEILE_6
	call ASCII_R
	call ASCII_A
	call ASCII_M
	call ASCII_SPACE
	ldi temp1,LOW (SRAM_START)
	ldi temp2,HIGH(SRAM_START)
	call ANZEIGE_5_STELLEN_TEMP1_TEMP2
	call ASCII_SPACE
	ldi temp1,LOW (RAMEND)
	ldi temp2,HIGH(RAMEND)
	call ANZEIGE_5_STELLEN_TEMP1_TEMP2
	call ASCII_SPACE
	ldi temp1,LOW (RAMEND)
	ldi temp2,HIGH(RAMEND)
	subi temp1,LOW (SRAM_START)
	sbci temp2,HIGH(SRAM_START)
	call ANZEIGE_5_STELLEN_TEMP1_TEMP2
	; 
	call ASCII_CURSOR_ZEILE_8
	call ASCII_S
	call ASCII_C
	call ASCII_L
	call ASCII_SPACE
	ldi temp1,BYTE1(TWI_SCL_BERECHNET)
	ldi temp2,BYTE2(TWI_SCL_BERECHNET)
	ldi temp3,BYTE3(TWI_SCL_BERECHNET)
	ldi temp4,BYTE4(TWI_SCL_BERECHNET)
	call ANZEIGE_8_STELLEN_TEMP1_TEMP2_TEMP3
	; 
	call ASCII_CURSOR_ZEILE_10
	call ASCII_S
	call ASCII_C
	call ASCII_A
	call ASCII_N
	call ASCII_DOPPEL_PUNKT
	call ASCII_SPACE
	call TWI_SCAN

	call WAIT_100ms
ret
;-------------------------------------------------------------------------------
MENUE_INFO:
	call ANZEIGE_BEGRUESSUNG
ret
;-------------------------------------------------------------------------------
MENUE_WARNUNG:
	call ASCII_CURSOR_ZEILE_2
	call ASCII_W
	call ASCII_A
	call ASCII_R
	call ASCII_N
	call ASCII_U
	call ASCII_N
	call ASCII_G

	call ASCII_CURSOR_ZEILE_4
	LDS temp1,(adr_WARNUNG_CODE)
	call ANZEIGE_3_STELLEN_TEMP1

	call ASCII_CURSOR_ZEILE_6
	LDS temp1,(adr_WARNUNG_WERT1)
	call ANZEIGE_3_STELLEN_TEMP1
	call ASCII_CURSOR_ZEILE_7
	LDS temp1,(adr_WARNUNG_WERT2)
	call ANZEIGE_3_STELLEN_TEMP1
	call ASCII_CURSOR_ZEILE_8
	LDS temp1,(adr_WARNUNG_WERT3)
	call ANZEIGE_3_STELLEN_TEMP1
	call ASCII_CURSOR_ZEILE_9
	LDS temp1,(adr_WARNUNG_WERT4)
	call ANZEIGE_3_STELLEN_TEMP1

	call WAIT_100ms
ret
;-------------------------------------------------------------------------------
MENUE_ASCII:
	clr temp
MENUE_ASCII_s:
	call ASCII_TEMP
	inc temp
	cpi temp,220
	brne MENUE_ASCII_s
	call WAIT_10ms
ret
;-------------------------------------------------------------------------------
MENUE_HH:
	; hh					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_S
	call ASCII_T
	call ASCII_U
	call ASCII_N
	call ASCII_D
	call ASCII_E

	LDS temp1,(adr_hh)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_hh),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
MENUE_MM:
	; mm					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_M
	call ASCII_I
	call ASCII_N
	call ASCII_U
	call ASCII_T
	call ASCII_E

	LDS temp1,(adr_mm)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_mm),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
MENUE_SS:
	; ss					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_S
	call ASCII_E
	call ASCII_K
	call ASCII_U
	call ASCII_N
	call ASCII_D
	call ASCII_E

	LDS temp1,(adr_ss)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_ss),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_ZEIT_KURZ	; ZEIT	
	ret
;-------------------------------------------------------------------------------
MENUE_TAG:
	; TAG					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_T
	call ASCII_A
	call ASCII_G

	LDS temp1,(adr_TAG)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_TAG),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
MENUE_MONAT:
	; MONAT					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_M
	call ASCII_O
	call ASCII_N
	call ASCII_A
	call ASCII_T

	LDS temp1,(adr_MONAT)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_MONAT),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
MENUE_JAHR:
	; JAHR					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_J
	call ASCII_A
	call ASCII_H
	call ASCII_R

	LDS temp1,(adr_JAHR)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_JAHR),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
MENUE_WOCHENTAG:
	; WOCHENTAG					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_W
	call ASCII_O
	call ASCII_C
	call ASCII_H
	call ASCII_E
	call ASCII_N
	call ASCII_MINUS
	call ASCII_T
	call ASCII_A
	call ASCII_G



	LDS temp1,(adr_WOCHENTAG)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_WOCHENTAG),temp1

	call ASCII_CURSOR_ZEILE_9
	call ANZEIGE_WOCHENTAG_KURZ
	call ASCII_SPACE
	call ANZEIGE_DATUM_KURZ	; DATUM	
	ret
;-------------------------------------------------------------------------------
MENUE_ALARM_SCHWELLE:
	; ALARM_SCHWELLE					
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_EDIT_KURZ
	call ASCII_A
	call ASCII_L
	call ASCII_A
	call ASCII_R
	call ASCII_M
	call ASCII_MINUS
	call ASCII_S
	call ASCII_C
	call ASCII_H
	call ASCII_W
	call ASCII_E
	call ASCII_L
	call ASCII_L
	call ASCII_E

	LDS temp1,(adr_BMA020_ALARM_SCHWELLE)
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	STS (adr_BMA020_ALARM_SCHWELLE),temp1

	call ASCII_CURSOR_ZEILE_9
	LDS temp1,(adr_BMA020_ALARM_SCHWELLE)
	call ANZEIGE_3_STELLEN_TEMP1
	ret
;-------------------------------------------------------------------------------
MENUE_SAVE_RESET:
	call ASCII_CURSOR_ZEILE_6
	call ASCII_S
	call ASCII_A
	call ASCII_V
	call ASCII_E
	call ASCII_PLUS
	call ASCII_R
	call ASCII_E
	call ASCII_S
	call ASCII_E
	call ASCII_T
	call ASCII_CURSOR_ZEILE_8
	call ASCII_d_
	call ASCII_u_
	call ASCII_r_
	call ASCII_c_
	call ASCII_h_
	call ASCII_SPACE
	call ASCII_T
	call ASCII_A
	call ASCII_S
	call ASCII_T
	call ASCII_E
	call ASCII_SPACE
	call ASCII_PLUS

	clr temp1
	call TASTEN_WERT_PLUS_MINUS_TEMP1
	tst temp1
	brne MENUE_SAVE_RESET_w
	ret
MENUE_SAVE_RESET_w:
	; ANZEIGE				
	call GRAFIC_CLEAR
	call ASCII_CURSOR_ZEILE_6
	call ANZEIGE_TEXT_WAIT_KURZ
	call EEPROM_KONFIGURATION_SPEICHERN
	call DS1307_UHR_STELLEN_INITIALISIEREN
	call ASCII_PUNKT
	call wait_1s
	call ASCII_PUNKT
	call wait_1s
	call ASCII_PUNKT
	call wait_1s
	CLI							; INTERRUPTS sperren	
	jmp RESET
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
